#include <stdio.h>
#include <sys/stat.h>
#include <errno.h>
#include <sys/stat.h>
#include "citadel.h"

extern struct config config;
extern struct usersupp usersupp;
extern struct quickroom quickroom;
extern struct fullroom fullroom;
extern struct msgmain msgmain;
extern char curr_user[];
extern int curr_rm;
extern int logged_in;
extern FILE *download_fp;
extern FILE *upload_fp;
extern char temp[];

extern int errno;

extern long extract_long();
extern int extract_int();

/* these variables are used in multiple routines, but only in file_ops.c */
char upl_file[256];
char upl_path[256];
char upl_comment[256];
char upl_filedir[256];



/*
 * delete a file from the room directory
 */
void cmd_delf(filename)
char filename[]; {
	char pathname[64];
	int a;

	if (!logged_in) {
		printf("%d Not logged in.\n",ERROR+NOT_LOGGED_IN);
		return;
		}

	if (!is_room_aide()) {
		printf("%d Higher access required.\n",
			ERROR+HIGHER_ACCESS_REQUIRED);
		return;
		}


	if ((quickroom.QRflags & QR_DIRECTORY) == 0) {
		printf("%d No directory in this room.\n",ERROR+NOT_HERE);
		return;
		}

	if (strlen(filename)==0) {
		printf("%d You must specify a file name.\n",
			ERROR+FILE_NOT_FOUND);
		return;
		}
	for (a=0; a<strlen(filename); ++a)
		if (filename[a]=='/') filename[a] = '_';
	sprintf(pathname,"./files/%s/%s",quickroom.QRdirname,filename);
	a=unlink(pathname);
	if (a==0) printf("%d File '%s' deleted.\n",OK,pathname);
	else printf("%d File '%s' not found.\n",ERROR+FILE_NOT_FOUND,pathname);
	}




/*
 * move a file from one room directory to another
 */
void cmd_movf(cmdbuf)
char cmdbuf[]; {
	char filename[256];
	char pathname[256];
	char newpath[256];
	char newroom[256];
	char buf[256];
	FILE *fp;
	int a;
	int target_room = (-1);
	struct quickroom qrbuf;

	extract(filename,cmdbuf,0);
	extract(newroom,cmdbuf,1);

	if (!logged_in) {
		printf("%d Not logged in.\n",ERROR+NOT_LOGGED_IN);
		return;
		}

	if (!is_room_aide()) {
		printf("%d Higher access required.\n",
			ERROR+HIGHER_ACCESS_REQUIRED);
		return;
		}

	if ((quickroom.QRflags & QR_DIRECTORY) == 0) {
		printf("%d No directory in this room.\n",ERROR+NOT_HERE);
		return;
		}

	if (strlen(filename)==0) {
		printf("%d You must specify a file name.\n",
			ERROR+FILE_NOT_FOUND);
		return;
		}

	for (a=0; a<strlen(filename); ++a)
		if (filename[a]=='/') filename[a] = '_';
	sprintf(pathname,"./files/%s/%s",quickroom.QRdirname,filename);
	if (access(pathname,0)!=0) {
		printf("%d File '%s' not found.\n",
			ERROR+FILE_NOT_FOUND,pathname);
		return;
		}

	fp=fopen("quickroom","r+");
	for (a=0; a<MAXROOMS; ++a) {
		getroom(&qrbuf,a);
		if (!strucmp(qrbuf.QRname,newroom)) target_room = a;
		}
	if (target_room < 0) {
		printf("%d Room '%s' not found.\n",
			ERROR+ROOM_NOT_FOUND,newroom);
		fclose(fp);
		return;
		}
	fseek(fp,((long)target_room*(long)sizeof(struct quickroom)),0);
	fread((char *)&qrbuf,sizeof(struct quickroom),1,fp);
	fclose(fp);
	if ((qrbuf.QRflags & QR_DIRECTORY) == 0) {
		printf("%d '%s' is not a directory room.\n",
			ERROR+NOT_HERE,qrbuf.QRname);
		return;
		}
	sprintf(newpath,"./files/%s/%s",qrbuf.QRdirname,filename);
	if (link(pathname,newpath)!=0) {
		printf("%d Couldn't move file.  errno=%d\n",ERROR,errno);
		return;
		}
	unlink(pathname);

	/* this is a crude method of copying the file description */
	sprintf(buf,"cat ./files/%s/filedir |grep %s >>./files/%s/filedir",
		quickroom.QRdirname,
		filename,
		qrbuf.QRdirname);
	system(buf);
	printf("%d File '%s' has been moved.\n",OK,filename);
	}


/*
 * send a file over the net
 */
void cmd_netf(cmdbuf)
char cmdbuf[]; {
	char pathname[256],filename[256],destsys[256],buf[256],outfile[256];
	int a,e;
	long now;
	FILE *ofp;

	extract(filename,cmdbuf,0);
	extract(destsys,cmdbuf,1);

	if (!logged_in) {
		printf("%d Not logged in.\n",ERROR+NOT_LOGGED_IN);
		return;
		}

	if (!is_room_aide()) {
		printf("%d Higher access required.\n",
			ERROR+HIGHER_ACCESS_REQUIRED);
		return;
		}

	if ((quickroom.QRflags & QR_DIRECTORY) == 0) {
		printf("%d No directory in this room.\n",ERROR+NOT_HERE);
		return;
		}

	if (strlen(filename)==0) {
		printf("%d You must specify a file name.\n",
			ERROR+FILE_NOT_FOUND);
		return;
		}

	for (a=0; a<strlen(filename); ++a)
		if (filename[a]=='/') filename[a] = '_';
	sprintf(pathname,"./files/%s/%s",quickroom.QRdirname,filename);
	if (access(pathname,0)!=0) {
		printf("%d File '%s' not found.\n",
			ERROR+FILE_NOT_FOUND,pathname);
		return;
		}
	sprintf(buf,"sysop@%s",destsys);
	e=alias(buf);
	if (e!=M_BINARY) {
		printf("%d No such system: '%s'\n",
			ERROR+NO_SUCH_SYSTEM,destsys);
		return;
		}
	sprintf(outfile,"%s/network/spoolin/nsf.%d",BBSDIR,getpid());
	ofp=fopen(outfile,"a");
	if (ofp==NULL) {
		printf("%d internal error\n",ERROR);
		return;
		}

	putc(255,ofp);
	putc(MES_NORMAL,ofp);
	putc(0,ofp);
	fprintf(ofp,"Pcit%ld",usersupp.eternal); putc(0,ofp);
	time(&now);
	fprintf(ofp,"T%ld",now); putc(0,ofp);
	fprintf(ofp,"A%s",usersupp.fullname); putc(0,ofp);
	fprintf(ofp,"O%s",quickroom.QRname); putc(0,ofp);
	fprintf(ofp,"N%s",NODENAME); putc(0,ofp);
	fprintf(ofp,"D%s",destsys); putc(0,ofp);
	fprintf(ofp,"SFILE"); putc(0,ofp);
	putc('M',ofp);
	fclose(ofp);

	sprintf(buf,"cd ./files/%s; uuencode %s <%s 2>/dev/null >>%s",
		quickroom.QRdirname,filename,filename,outfile);
	system(buf);

	ofp = fopen(outfile,"a");
	putc(0,ofp);
	fclose(ofp);

	printf("%d File '%s' has been sent to %s.\n",OK,filename,destsys);
	fflush(stdout);
	system("nohup netproc >/dev/null 2>&1 &");
	return;
	}


/*
 * open a file for downloading
 */
void cmd_open(cmdbuf)
char *cmdbuf; {
	char filename[256];
	char pathname[256];
	int a;
	struct stat statbuf;

	extract(filename,cmdbuf,0);

	if (!logged_in) {
		printf("%d Not logged in.\n",ERROR+NOT_LOGGED_IN);
		return;
		}

	if ((quickroom.QRflags & QR_DIRECTORY) == 0) {
		printf("%d No directory in this room.\n",ERROR+NOT_HERE);
		return;
		}

	if (strlen(filename)==0) {
		printf("%d You must specify a file name.\n",
			ERROR+FILE_NOT_FOUND);
		return;
		}

	if (download_fp != NULL) {
		printf("%d You already have a download file open.\n",ERROR);
		return;
		}

	for (a=0; a<strlen(filename); ++a)
		if (filename[a]=='/') filename[a] = '_';
	sprintf(pathname,"./files/%s/%s",quickroom.QRdirname,filename);
	
	download_fp = fopen(pathname,"r");
	if (download_fp == NULL) {
		a = errno;
		if (a==ENOENT) {
			printf("%d File '%s' not found.\n",
				ERROR+FILE_NOT_FOUND,pathname);
			}
		else {
			printf("%d Cannot open '%s', errno=%d\n",
				ERROR+FILE_NOT_FOUND,pathname,a);
			}
		return;
		}
	
	stat(pathname,&statbuf);
	printf("%d %ld\n",OK,statbuf.st_size);
	}

/*
 * open an image file
 */
void cmd_oimg(cmdbuf)
char *cmdbuf; {
	char filename[256];
	char pathname[256];
	int a;
	struct stat statbuf;

	extract(filename,cmdbuf,0);

	if (strlen(filename)==0) {
		printf("%d You must specify a file name.\n",
			ERROR+FILE_NOT_FOUND);
		return;
		}

	if (download_fp != NULL) {
		printf("%d You already have a download file open.\n",ERROR);
		return;
		}

	for (a=0; a<strlen(filename); ++a)
		if (filename[a]=='/') filename[a] = '_';
	sprintf(pathname,"./images/%s.gif",filename);
	
	download_fp = fopen(pathname,"r");
	if (download_fp == NULL) {
		a = errno;
		if (a==ENOENT) {
			printf("%d File '%s' not found.\n",
				ERROR+FILE_NOT_FOUND,pathname);
			}
		else {
			printf("%d Cannot open '%s', errno=%d\n",
				ERROR+FILE_NOT_FOUND,pathname,a);
			}
		return;
		}
	
	stat(pathname,&statbuf);
	printf("%d %ld\n",OK,statbuf.st_size);
	}

/*
 * open a file for uploading
 */
void cmd_uopn(cmdbuf)
char *cmdbuf; {
	int a;
	struct stat statbuf;

	extract(upl_file,cmdbuf,0);
	extract(upl_comment,cmdbuf,1);

	if (!logged_in) {
		printf("%d Not logged in.\n",ERROR+NOT_LOGGED_IN);
		return;
		}

	if ((quickroom.QRflags & QR_DIRECTORY) == 0) {
		printf("%d No directory in this room.\n",ERROR+NOT_HERE);
		return;
		}

	if (strlen(upl_file)==0) {
		printf("%d You must specify a file name.\n",
			ERROR+FILE_NOT_FOUND);
		return;
		}

	if (upload_fp != NULL) {
		printf("%d You already have a upload file open.\n",ERROR);
		return;
		}

	for (a=0; a<strlen(upl_file); ++a)
		if (upl_file[a]=='/') upl_file[a] = '_';
	sprintf(upl_path,"./files/%s/%s",quickroom.QRdirname,upl_file);
	sprintf(upl_filedir,"./files/%s/filedir",quickroom.QRdirname);
	
	upload_fp = fopen(upl_path,"r");
	if (upload_fp != NULL) {
		fclose(upload_fp);
		upload_fp = NULL;
		printf("%d '%s' already exists\n",
			ERROR+ALREADY_EXISTS,upl_path);
		return;
		}

	upload_fp = fopen(upl_path,"w");
	if (upload_fp == NULL) {
		printf("%d Cannot open '%s', errno=%d\n",
			ERROR,upl_path,errno);
		return;
		}
	printf("%d Ok\n",OK);
	}


/*
 * close the download file
 */
void cmd_clos() {
	
	if (download_fp == NULL) {
		printf("%d You don't have a download file open.\n",ERROR);
		return;
		}

	fclose(download_fp);
	download_fp = NULL;
	printf("%d Ok\n",OK);
	}


/*
 * abort and upload
 */
void abort_upl() {
	if (upload_fp != NULL) {
		fclose(upload_fp);
		upload_fp = NULL;
		}
	unlink(upl_path);
	}



/*
 * close the upload file
 */
void cmd_ucls(cmd)
char *cmd; {
	FILE *fp;
	long now;
	
	if (upload_fp == NULL) {
		printf("%d You don't have an upload file open.\n",ERROR);
		return;
		}

	fclose(upload_fp);
	upload_fp = NULL;

	if (!strucmp(cmd,"1")) {
		printf("%d File '%s' saved.\n",OK,upl_path);
		fp = fopen(upl_filedir,"a");
		if (fp==NULL) fp=fopen(upl_filedir,"w");
		if (fp!=NULL) {
			fprintf(fp,"%s %s\n",upl_file,upl_comment);
			fclose(fp);
			}

		/* put together an upload notice */
		time(&now);
		fp=fopen(temp,"wb");
		putc(255,fp);
		putc(MES_NORMAL,fp);
		putc(0,fp);
		fprintf(fp,"Pcit%ld",usersupp.eternal); putc(0,fp);
		fprintf(fp,"T%ld",now); putc(0,fp);
		fprintf(fp,"A%s",curr_user); putc(0,fp);
		fprintf(fp,"O%s",quickroom.QRname); putc(0,fp);
		fprintf(fp,"N%s",NODENAME); putc(0,fp); putc('M',fp);
		fprintf(fp,"NEW UPLOAD: '%s'\n %s\n",upl_file,upl_comment);
		putc(0,fp);
		fclose(fp);
		save_message(temp,"",0,M_LOCAL);

		}
	else {
		abort_upl();
		printf("%d File '%s' aborted.\n",OK,upl_path);
		}
	}

/*
 * read from the download file
 */
void cmd_read(cmdbuf)
char cmdbuf[]; {
	long start_pos;
	int bytes;
	char buf[4096];

	start_pos = extract_long(cmdbuf,0);
	bytes = extract_int(cmdbuf,1);
	
	if (download_fp == NULL) {
		printf("%d You don't have a download file open.\n",ERROR);
		return;
		}

	if (bytes > 4096) {
		printf("%d You may not read more than 4096 bytes.\n",ERROR);
		return;
		}

	fseek(download_fp,start_pos,0);
	fread(buf,bytes,1,download_fp);
	printf("%d %d\n",BINARY_FOLLOWS,bytes);
	fwrite(buf,bytes,1,stdout);
	fflush(stdout);
	}



/*
 * write to the upload file
 */
void cmd_writ(cmdbuf)
char cmdbuf[]; {
	int bytes;
	char buf[4096];

	bytes = extract_int(cmdbuf,0);
	
	if (upload_fp == NULL) {
		printf("%d You don't have an upload file open.\n",ERROR);
		return;
		}

	if (bytes > 4096) {
		printf("%d You may not write more than 4096 bytes.\n",ERROR);
		return;
		}

	printf("%d %d\n",SEND_BINARY,bytes);
	fflush(stdout);
	fread(buf,bytes,1,stdin);
	fwrite(buf,bytes,1,upload_fp);
	}

