#include <stdio.h>
#include <fcntl.h>
#include "citadel.h"

#define MSGS_ALL	0
#define MSGS_OLD	1
#define MSGS_NEW	2
#define MSGS_FIRST	3
#define MSGS_LAST	4

extern struct config config;
extern struct msgmain msgmain;
extern struct fullroom fullroom;
extern struct usersupp usersupp;
extern struct quickroom quickroom;
extern int logged_in;
extern int curr_rm;
extern char curr_user[];
extern char temp[];
int twitroom;

long atol();


/*
 * Aliasing for network mail.
 * (Error messages have been commented out, because this is a server.)
 */
int alias(name)		/* process alias and routing info for mail */
char name[]; {
	FILE *fp;
	int a,b,file;
	char aaa[300],bbb[300];
	
	fp=fopen("network/mail.aliases","r");
	if (fp==NULL) return(2);
GNA:	strcpy(aaa,""); strcpy(bbb,"");
	do {
		a=getc(fp);
		if (a==',') a=0;
		if (a>0) {
			b=strlen(aaa);
			aaa[b]=a;
			aaa[b+1]=0;
			}
		} while(a>0);
	do {
		a=getc(fp);
		if (a==10) a=0;
		if (a>0) {
			b=strlen(bbb);
			bbb[b]=a;
			bbb[b+1]=0;
			}
		} while(a>0);
	if (a<0) {
		fclose(fp);
		goto DETYPE;
		}
	if (strucmp(name,aaa)) goto GNA;
	fclose(fp);
	strcpy(name,bbb);
	/* printf("*** Mail is being forwarded to %s\n",name); */

DETYPE:	/* determine local or remote type, see citadel.h */
	for (a=0; a<strlen(name); ++a) if (name[a]=='!') return(M_UUCP);
	for (a=0; a<strlen(name); ++a)
		if (name[a]=='@')
			for (b=a; b<strlen(name); ++b)
				if (name[b]=='.') return(M_UUCP);
	b=0; for (a=0; a<strlen(name); ++a) if (name[a]=='@') ++b;
	if (b>1) {
		/* printf("Too many @'s in address\n"); */
		return(M_ERROR);
		}
	if (b==1) {
		for (a=0; a<strlen(name); ++a)
			if (name[a]=='@') strcpy(bbb,&name[a+1]);
		while (bbb[0]==32) strcpy(bbb,&bbb[1]);
		fp = fopen("network/mail.sysinfo","r");
		if (fp==NULL) return(M_ERROR);
GETSN:		do {
			a=getstring(fp,aaa);
			} while ((a>=0)&&(strucmp(aaa,bbb)));
		a=getstring(fp,aaa);
		if (!strncmp(aaa,"use ",4)) {
			strcpy(bbb,&aaa[4]);
			fseek(fp,0L,0);
			goto GETSN;
			}
		fclose(fp);
		if (!strncmp(aaa,"uum",3)) {
			strcpy(bbb,name);
			for (a=0; a<strlen(bbb); ++a) {
				if (bbb[a]=='@') bbb[a]=0;
				if (bbb[a]==' ') bbb[a]='_';
				}
			while(bbb[strlen(bbb)-1]=='_') bbb[strlen(bbb)-1]=0;
			sprintf(name,&aaa[4],bbb);
			return(M_UUCP);
			}
		if (!strncmp(aaa,"bin",3)) {
			strcpy(aaa,name); strcpy(bbb,name);
			while (aaa[strlen(aaa)-1]!='@') aaa[strlen(aaa)-1]=0;
			aaa[strlen(aaa)-1]=0;
			while (aaa[strlen(aaa)-1]==' ') aaa[strlen(aaa)-1]=0;
			while (bbb[0]!='@') strcpy(bbb,&bbb[1]);
			strcpy(bbb,&bbb[1]);
			while (bbb[0]==' ') strcpy(bbb,&bbb[1]);
			sprintf(name,"%s @%s",aaa,bbb);
			return(M_BINARY);
			}
		return(M_ERROR);
		}
	return(M_LOCAL);
	}


void get_mm() {
	FILE *fp;

	fp=fopen("MMstructure","r");
	fread((char *)&msgmain,sizeof(struct msgmain),1,fp);
	fclose(fp);
	}

/*
 * cmd_msgs()  -  get list of message #'s in this room
 */
void cmd_msgs(cmdbuf)
char *cmdbuf; {
	int a;
	int mode;
	char which[256];
	int cm_howmany;

	extract(which,cmdbuf,0);

	mode = MSGS_ALL;
	strcat(which,"   ");
	if (!struncmp(which,"OLD",3))	mode = MSGS_OLD;
	if (!struncmp(which,"NEW",3))	mode = MSGS_NEW;
	if (!struncmp(which,"FIRST",5))	{
		mode = MSGS_FIRST;
		cm_howmany = extract_int(cmdbuf,1);
		}
	if (!struncmp(which,"LAST",4))	{
		mode = MSGS_LAST;
		cm_howmany = extract_int(cmdbuf,1);
		}

	if (!logged_in) {
		printf("%d not logged in\n",ERROR+NOT_LOGGED_IN);
		return;
		}
	if (curr_rm < 0) {
		printf("%d no room\n",ERROR);
		return;
		}
	get_mm();
	get_fullroom(&fullroom,curr_rm);
	getuser(&usersupp,curr_user);
	printf("%d messages...\n",LISTING_FOLLOWS);
	for (a=0; a<MSGSPERRM; ++a) 
	    if ( (fullroom.FRnum[a] >= msgmain.MMlowest)
	       && (fullroom.FRnum[a] >=0)
	       && ( 

(mode==MSGS_ALL)
|| ((mode==MSGS_OLD) && (fullroom.FRnum[a] <= usersupp.lastseen[curr_rm]))
|| ((mode==MSGS_NEW) && (fullroom.FRnum[a] > usersupp.lastseen[curr_rm]))
|| ((mode==MSGS_NEW) && (fullroom.FRnum[a] >= usersupp.lastseen[curr_rm])
		     && (usersupp.flags & US_LASTOLD))
|| ((mode==MSGS_LAST)&& (a>=(MSGSPERRM-cm_howmany)))
|| ((mode==MSGS_FIRST)&&(a<cm_howmany))

			)
		)
		printf("%ld\n",fullroom.FRnum[a]);
	printf("000\n");
	}


/*
 * pattern2()  -  searches for patn within search string, returns pos 
 */ 
int pattern2(search,patn)
char search[];
char patn[]; {
	int a;
	for (a=0; a<strlen(search); ++a) {
		if (!struncmp(&search[a],patn,strlen(patn))) return(a);
		}
	return(-1);
	}


/* 
 * help_subst()  -  support routine for help file viewer
 */
void help_subst(strbuf,source,dest)
char strbuf[];
char source[];
char dest[]; {
	char workbuf[256];
	int p;

	while (p=pattern2(strbuf,source), (p>=0)) {
		strcpy(workbuf,&strbuf[p+strlen(source)]);
		strcpy(&strbuf[p],dest);
		strcat(strbuf,workbuf);
		}
	}


void do_help_subst(buffer)
char buffer[]; {
	char buf2[16];

	help_subst(buffer,"^nodename",config.c_nodename);
	help_subst(buffer,"^humannode",config.c_humannode);
	help_subst(buffer,"^fqdn",config.c_fqdn);
	help_subst(buffer,"^username",usersupp.fullname);
	sprintf(buf2,"%ld",usersupp.eternal);
	help_subst(buffer,"^usernum",buf2);
	help_subst(buffer,"^sysadm",config.c_sysadm);
	help_subst(buffer,"^variantname",CITADEL);
	sprintf(buf2,"%d",config.c_maxsessions);
	help_subst(buffer,"^maxsessions",buf2);
	}



/*
 * fmout()  -  Citadel text formatter and paginator.
 *             Although the original purpose of this routine was to format
 *             text to the reader's screen width, all we're really using it
 *             for here is to format text out to 80 columns before sending it
 *             to the client.  The client software may reformat it again.
 */
void fmout(width,fp,subst)
int width;		/* screen width to use */
FILE *fp;		/* where are we going to get our text from? */
char subst;		/* nonzero if we should use hypertext mode */
	{
	int a,b,c,real,old;
	char aaa[140];
	char buffer[256];
	
	strcpy(aaa,""); old=255;
	strcpy(buffer,"");
	c=1; /* c is the current pos */

FMTA:	if (subst) {
		while ( (!feof(fp)) && (strlen(buffer)<126) ) {
			a=getc(fp);
			buffer[strlen(buffer)+1] = 0;
			buffer[strlen(buffer)] = a;
			}

		do_help_subst(buffer);

		buffer[strlen(buffer)+1] = 0;
		a=buffer[0];
		strcpy(buffer,&buffer[1]);
		}
	
	else a=getc(fp);

	old=real;
	real=a;
	if (a<=0) goto FMTEND;
	
	if ( ((a==13)||(a==10)) && (old!=13) && (old!=10) ) a=32;
	if ( ((old==13)||(old==10)) && (isspace(real)) ) {
		printf("\n");
		c=1;
		}
	if (a>126) goto FMTA;

	if (a>32) {
	if ( ((strlen(aaa)+c)>(width-5)) && (strlen(aaa)>(width-5)) )
		{ printf("\n%s",aaa); c=strlen(aaa); aaa[0]=0;
		}
	 b=strlen(aaa); aaa[b]=a; aaa[b+1]=0; }
	if (a==32) {
		if ((strlen(aaa)+c)>(width-5)) { 
			printf("\n");
			c=1;
			}
		printf("%s ",aaa); ++c; c=c+strlen(aaa);
		strcpy(aaa,"");
		goto FMTA;
		}
	if ((a==13)||(a==10)) {
		printf("%s\n",aaa);
		c=1;
		strcpy(aaa,"");
		goto FMTA;
		}
	goto FMTA;

FMTEND:	printf("\n");
	}





/*
 * get a message off disk.  (interim command)
 */
cmd_msg0(msgid)
char *msgid; {
	long msg_num, msg_pos;
	int a,ch,och,len;
	FILE *msg;
	char format_type,anon_flag;
	char buf[1024];

	msg_num = atol(msgid);
	msg_pos = (-1L);

	if (!logged_in) {
		printf("%d Not logged in.\n",ERROR+NOT_LOGGED_IN);
		return;
		}
	if (curr_rm < 0) {
		printf("%d No room selected.\n",ERROR);
		return;
		}

	if (msg_num < msgmain.MMlowest) {
		printf("%d No message.\n",ERROR);
		return;
		}

	for (a=0; a<MSGSPERRM; ++a) if (fullroom.FRnum[a] == msg_num)
		msg_pos = fullroom.FRpos[a];

	if (msg_pos < 0L) {
		get_fullroom(&fullroom,curr_rm);
		for (a=0; a<MSGSPERRM; ++a) if (fullroom.FRnum[a] == msg_num)
			msg_pos = fullroom.FRpos[a];
		}

	if (msg_pos < 0L) {
		printf("%d No message.\n",ERROR);
		return;
		}

	msg = fopen("msgmain","r");
	if (msg==NULL) {
		printf("%d ?Can't open msgmain!\n",ERROR+INTERNAL_ERROR);
		return;
		}

	fseek(msg,msg_pos,0);
	ch = wrapgetc(msg,config.c_msgbase);
	if (ch != 255) {
		printf("%d ?Can't find message!  pos = %ld\n",
			ERROR+INTERNAL_ERROR, msg_pos);
		return;
		}

	printf("%d Message %ld:\n",LISTING_FOLLOWS,msg_num);

	anon_flag = wrapgetc(msg,config.c_msgbase);
	format_type = wrapgetc(msg,config.c_msgbase);
	printf("type=%d\n",format_type);

	if (anon_flag == MES_ANON) printf("nhdr=yes\n");

	while(ch = wrapgetc(msg,config.c_msgbase), (ch!='M' && ch!=0)) {
		wrapgetfield(msg,buf,config.c_msgbase);

		if (ch=='A') {
			if (anon_flag==MES_ANON) printf("from=****\n",buf);
			else if (anon_flag==MES_AN2) printf("from=anonymous\n");
			else printf("from=%s\n",buf);
			}
		else if (ch=='P') printf("path=%s\n",buf);
		else if (ch=='U') printf("subj=%s\n",buf);
		else if (ch=='I') printf("msgn=%s\n",buf);
		else if (ch=='H') printf("hnod=%s\n",buf);
		else if (ch=='O') printf("room=%s\n",buf);
		else if (ch=='N') printf("node=%s\n",buf);
		else if (ch=='R') printf("rcpt=%s\n",buf);
		else if (ch=='T') printf("time=%s\n",buf);
		/* else printf("fld%c=%s\n",ch,buf); */
		}

	if (ch==0) {
		printf("*** ?Message truncated\n000\n");
		fclose(msg);
		return;
		}

	printf("text\n");	/* signify start of msg text */

	if (format_type == 1) {
		och = 0;
		len = 0;
		while(och=ch, ch = getc(msg), ch>0) {
			++len;
			putc(ch,stdout);
			}
		if ((och!=10)||(len>=255)) {
			len = 0;
			putc(10,stdout);
			}
		}
	if (format_type == 0) {
		fmout(80,msg,0);	/* client will format */
		}

	fclose(msg);
	printf("000\n");
	}


/*
 * message base operation to send a message to the master file
 */
void send_message(filename,retbuf)
char filename[];		/* tempfilename of proper message */
struct smreturn *retbuf;	/* return information */
{

int file,a,c,d;
long bb,cc,templen,hibytes,origpos,bytes_written;
char sbuf[BUFSIZ];
char mid[30];
FILE *fp,*fp2;
struct msgmain msgmain;

	file=open("MMstructure",O_RDWR);
	lseek(file,0L,0);
	a=read(file,&msgmain,sizeof(struct msgmain));
	lseek(file,0L,0);
	close(file);

	origpos=msgmain.MMcurpos;
	++msgmain.MMhighest;
	sprintf(mid,"I%ld",msgmain.MMhighest);

	/* measure the message */
	fp=fopen(filename,"r");
	fseek(fp,0L,2);
	templen=ftell(fp);
	fclose(fp);
	templen=templen+((long)strlen(mid))+2L;

	/* check for FF bytes, to determine how many msgs we're overwriting */
	hibytes=0L;
	fp=fopen("msgmain","rb");
	fseek(fp,msgmain.MMcurpos,0);
	cc=ftell(fp);
	for (bb=0L; bb<templen; ++bb) {
		if (cc>=MM_FILELEN) {
			fseek(fp,0L,0);
			cc=0L;
			}
		c=getc(fp); ++cc;
		if (c>127) ++hibytes;	/* bump count if hi bit set */
		}
	fclose(fp);
	msgmain.MMlowest=msgmain.MMlowest+hibytes;

	fp=fopen("msgmain","r+");
	fseek(fp,msgmain.MMcurpos,0);
	cc=ftell(fp);
	fp2=fopen(filename,"r");
	fread((char *)sbuf,3,1,fp2);
	fwrite((char *)sbuf,3,1,fp);
	fprintf(fp,"%s",mid);
	putc(0,fp);

	/* 3 header + mid (I field) + 1 zero-byte */
	bytes_written = 4L + ((long)strlen(mid));

	while (bytes_written < templen) {
		d=getc(fp2);
		if (d<0) d=0;
		putc(d,fp);
		++cc;
		if (cc>=MM_FILELEN) {
			fseek(fp,0L,0);
			cc = 0L;
			}
		++bytes_written;
		}

	msgmain.MMcurpos=ftell(fp);
	fclose(fp2);	/* done with temp file */
	fclose(fp);	/* done with master file */

	/* now update the message structure */
	file=open("MMstructure",O_RDWR);
	a=write(file,&msgmain,sizeof(struct msgmain));
	close(file);

	retbuf->smnumber=msgmain.MMhighest;
	retbuf->smpos=origpos;
	}


void loadtroom() {
	struct quickroom qrbuf;
	int a;
	unsigned newflags;

	/* first try to locate the twit room */
	for (a=0; a<MAXROOMS; ++a) {
		getroom(&qrbuf,a);
		if (!strucmp(qrbuf.QRname,config.c_twitroom)) {
			twitroom = a;
			return;
			}
		}

	/* if not found, try to create it  -  put it in the last slot */
	twitroom = get_free_room_slot(-1);
	if (twitroom>=0) {
		newflags = create_room(twitroom,config.c_twitroom,0,"");
		return;
		}

	/* as a last resort, point to Aide> */
	twitroom = 2;
	}


/*
 * this is a simple file copy routine.
 */
void copy_file(from,to)
char *from;
char *to; {
	FILE *ffp,*tfp;
	int a;

	ffp=fopen(from,"r");
	if (ffp==NULL) return;
	tfp=fopen(to,"w");
	if (tfp==NULL) {
		fclose(ffp);
		return;
		}
	while (a=getc(ffp), a>=0) {
		putc(a,tfp);
		}
	fclose(ffp);
	fclose(tfp);
	return;
	}



/*
 * message base operation to save a message and install its pointers
 */
void save_message(mtmp,rec,mtsflag,mailtype)
char mtmp[];			/* file containing proper message */
char rec[];			/* Recipient (if mail) */
char mtsflag;			/* 0 for normal, 1 to force Aide> room */
int mailtype; {			/* local or remote type, see citadel.h */
	int a,d,e,file;
	long aa,ee;
	struct usersupp tempUS;
	char aaa[100];
	struct smreturn smreturn;
	int hold_rm;

	lock_msgmain();
	send_message(mtmp,&smreturn);
	hold_rm=(-1);

	/* if the user is a twit, move to the twit room for posting */
	if (TWITDETECT) if (usersupp.axlevel==2) {
		if (twitroom<0) loadtroom();
		hold_rm=curr_rm;
		curr_rm=twitroom;
		}

	/* and if this message is destined for Aide> then go there */
	if (mtsflag) {
		hold_rm=curr_rm;
		curr_rm=2;
		}

	/* this call to usergoto() changes rooms if necessary.  It also
	   causes the latest fullroom structure to be read into memory */
	usergoto(curr_rm,0);

	/* read in the quickroom record, obtaining a lock... */
	lgetroom(&quickroom,curr_rm);
	get_fullroom(&fullroom,curr_rm);

	for (a=0; a<(MSGSPERRM-1); ++a) {
		fullroom.FRnum[a]=fullroom.FRnum[a+1];
		fullroom.FRpos[a]=fullroom.FRpos[a+1];
		}
	fullroom.FRnum[MSGSPERRM-1]=smreturn.smnumber;
	fullroom.FRpos[MSGSPERRM-1]=smreturn.smpos;

	put_fullroom(&fullroom,curr_rm);

	/* update quickroom */
	quickroom.QRhighest=fullroom.FRnum[MSGSPERRM-1];
	lputroom(&quickroom,curr_rm);

	/* Bump this user's messages posted counter.  Also, if the user is a
	   twit, give them access to the twit room. */
	lgetuser(&usersupp,curr_user);
	++usersupp.posted;
	if (curr_rm==twitroom) usersupp.generation[twitroom]=quickroom.QRgen;
	lputuser(&usersupp,curr_user);

	/* if mail, there's still more to do, if not, skip it */
	if ((curr_rm!=1)||(mtsflag)) goto ENTFIN;

	/* network mail - send a copy to the network program */
	if (mailtype!=M_LOCAL) {
		sprintf(aaa,"./network/spoolin/nm.%d",getpid());
		copy_file(mtmp,aaa);
		system("exec nohup ./netproc >/dev/null 2>&1 &");
		}

	/* local mail - put a copy in the recipient's mailbox */
	if (mailtype==M_LOCAL) {
		if (lgetuser(&tempUS,rec)==0) {
			for (e=0; e<(MAILSLOTS-1); ++e) {
				tempUS.mailnum[e]=tempUS.mailnum[e+1];
				tempUS.mailpos[e]=tempUS.mailpos[e+1];
				}
			tempUS.mailnum[MAILSLOTS-1]=smreturn.smnumber;
			tempUS.mailpos[MAILSLOTS-1]=smreturn.smpos;
			lputuser(&tempUS,rec);
			}
		}

	/* if we've posted in a room other than the current room, then we
	   have to now go back to the current room... */
ENTFIN:	if (hold_rm!=(-1)) {
		usergoto(hold_rm,0);
		}
	unlink(mtmp);		/* delete the temporary file */
	unlock_msgmain();	/* unlock the message base */
	}


/*
 * generate an administrative message and post it in the Aide> room
 */
aide_message(text)
char *text; {
	long now;
	FILE *fp;

	time(&now);
	fp=fopen(temp,"wb");
	putc(255,fp);
	putc(MES_NORMAL,fp);
	putc(0,fp);
	fprintf(fp,"Psysop"); putc(0,fp);
	fprintf(fp,"T%ld",now); putc(0,fp);
	fprintf(fp,"ACitadel"); putc(0,fp);
	fprintf(fp,"OAide"); putc(0,fp);
	fprintf(fp,"N%s",NODENAME); putc(0,fp); putc('M',fp);
	fprintf(fp,"%s\n",text);
	putc(0,fp);
	fclose(fp);
	save_message(temp,"",1,M_LOCAL);
	return(0);
	}



/*
 * build a binary message to be saved on disk
 */
void make_message(filename,author,recipient,room,type,net_type,format_type)
char filename[];	/* temporary file name */
struct usersupp *author;  /* author's usersupp structure */
char recipient[];	/* NULL if it's not mail */
char room[];		/* room where it's going */
int type;		/* see MES_ types in header file */
int net_type;		/* local or remote type, see citadel.h */
int format_type;	/* format type (see citadel.h) */
{ 
	FILE *fp;
	int a,b;
	long now;
	char dest_node[32];
	char buf[256];

	/* don't confuse the poor folks if it's not routed mail. */
	strcpy(dest_node,"");

	/* if net_type is M_BINARY, split out the destination node */
	if (net_type == M_BINARY) {
		strcpy(dest_node,NODENAME);
		for (a=0; a<strlen(recipient); ++a) {
			if (recipient[a]=='@') {
				recipient[a]=0;
				strcpy(dest_node,&recipient[a+1]);
				}
			}
		}

	/* if net_type is M_UUCP, set the dest node to 'internet' */
	if (net_type == M_UUCP) {
		strcpy(dest_node,"internet");
		}

	while (isspace(recipient[strlen(recipient)-1]))
		recipient[strlen(recipient)-1] = 0;

	time(&now);
	fp=fopen(filename,"w");
	putc(255,fp);
	putc(type,fp);	/* Normal or anonymous, see MES_ flags */
	putc(format_type,fp);	/* Formatted or unformatted */
	fprintf(fp,"Pcit%ld",author->eternal); putc(0,fp); /* path */
	fprintf(fp,"T%ld",now); putc(0,fp);		/* date/time */
	fprintf(fp,"A%s",author->fullname); putc(0,fp);	/* author */
	fprintf(fp,"O%s",quickroom.QRname); putc(0,fp);	/* room */
	fprintf(fp,"N%s",NODENAME); putc(0,fp);		/* nodename */
	fprintf(fp,"H%s",HUMANNODE); putc(0,fp);	/* human nodename */

	if (recipient[0]!=0) {	fprintf(fp,"R%s",recipient);	putc(0,fp); }
	if (dest_node[0]!=0) {	fprintf(fp,"D%s",dest_node);	putc(0,fp); }

	putc('M',fp);

	while (gets(buf), strcmp(buf,"000")) fprintf(fp,"%s\n",buf);
	putc(0,fp);
	fclose(fp);
	}





/*
 * message entry  -  mode 0
 */
void cmd_ent0(entargs)
char *entargs; {
	int post = 0;
	char recipient[256];
	int anon_flag = 0;
	int format_type = 0;

	int a,b,e;
	int mtsflag = 0;
	struct usersupp tempUS;
	char buf[256];

	post = extract_int(entargs,0);
	extract(recipient,entargs,1);
	anon_flag = extract_int(entargs,2);
	format_type = extract_int(entargs,3);


	/* first check to make sure the request is valid. */

	if (!logged_in) {
		printf("%d Not logged in.\n",ERROR+NOT_LOGGED_IN);
		return;
		}
	if (curr_rm < 0) {
		printf("%d No room selected.\n",ERROR);
		return;
		}
	if ((usersupp.axlevel<2)&&(curr_rm!=1)) {
		printf("%d Need to be validated to enter (except in Mail> to sysop)\n",
			ERROR+HIGHER_ACCESS_REQUIRED);
		return;
		}
	if ((usersupp.axlevel<4)&&(quickroom.QRflags&QR_NETWORK)) {
		printf("%d Need net privileges to enter here.\n",
			ERROR+HIGHER_ACCESS_REQUIRED);
		return;
		}
	if ((usersupp.axlevel<6)&&(quickroom.QRflags&QR_READONLY)) {
		printf("%d Sorry, this is a read-only room.\n",
			ERROR+HIGHER_ACCESS_REQUIRED);
		return;
		}

	mtsflag=0;
		
	buf[0]=0;
	if (curr_rm==1) {
		if (usersupp.axlevel>=2) {
			strcpy(buf,recipient);
			}
		else strcpy(buf,"sysop");
		e=alias(buf);			/* alias and mail type */
		if ((buf[0]==0) || (e==M_ERROR)) {
			printf("%d Unknown address - cannot send message.\n",
				ERROR+NO_SUCH_USER);
			return;
			}
		if ((e!=M_LOCAL)&&(usersupp.axlevel<4)) {
			printf("%d Net privileges required for network mail.\n",
				ERROR+HIGHER_ACCESS_REQUIRED);
			return;
			}
		if ((RESTRICT_INTERNET==1)&&(e==M_UUCP)
		   &&((usersupp.flags&US_INTERNET)==0)) {
			printf("%d You don't have access to Internet mail.\n",
				ERROR+HIGHER_ACCESS_REQUIRED);
			return;
			}
		if (!strucmp(buf,"sysop")) {
			mtsflag=1;
			goto SKFALL;
			}
		if (e!=M_LOCAL) goto SKFALL;	/* don't search local file  */
		if (!strucmp(buf,usersupp.fullname)) {
			printf("%d Can't send mail to yourself!\n",
				ERROR+NO_SUCH_USER);
			return;
			}

		/* Check to make sure the user exists; also get the correct
	 	* upper/lower casing of the name. 
	 	*/
		a = getuser(&tempUS,buf);
		if (a!=0) {
			printf("%d No such user.\n",ERROR+NO_SUCH_USER);
			return;
			}
		strcpy(buf,tempUS.fullname);
		}
	
SKFALL: b=MES_NORMAL;
	if (quickroom.QRflags&QR_ANONONLY) b=MES_ANON;
	if (quickroom.QRflags&QR_ANON2) {
		if (anon_flag==1) b=MES_AN2;
		}
	if (curr_rm!=1) buf[0]=0;

	/* If we're only checking the validity of the request, return
	 * success without creating the message.
	 */
	if (post==0) {
		printf("%d %s\n",OK,buf);
		return;
		}

	printf("%d send message\n",SEND_LISTING);
	fflush(stdout);
	make_message(temp,&usersupp,buf,quickroom.QRname,b,e,format_type);
	save_message(temp,buf,mtsflag,e);
	return;
	}


/*
 * Delete message from current room
 */
void cmd_dele(delstr)
long delstr; {
	long delnum;
	int a,ok;

	getuser(&usersupp,curr_user);
	if ((usersupp.axlevel < 6)
	   && (usersupp.eternal != quickroom.QRroomaide)) {
		printf("%d Higher access required.\n",
			ERROR+HIGHER_ACCESS_REQUIRED);
		return;
		}

	delnum = atol(delstr);
	if (curr_rm==1) {
		printf("%d Can't delete mail.\n",ERROR);
		return;
		}
	
	/* get room records, obtaining a lock... */
	lgetroom(&quickroom,curr_rm);
	get_fullroom(&fullroom,curr_rm);

	ok = 0;
	for (a=0; a<MSGSPERRM; ++a)
		if (fullroom.FRnum[a]==delnum) {
			fullroom.FRnum[a]=0L;
			fullroom.FRpos[a]=0L;
			ok = 1;
			}

	sort_fullroom(&fullroom);
	quickroom.QRhighest = fullroom.FRnum[MSGSPERRM-1];

	put_fullroom(&fullroom,curr_rm);
	lputroom(&quickroom,curr_rm);
	if (ok==1) printf("%d Message deleted.\n",OK);
	else printf("%d No message %ld.\n",ERROR,delnum);
	} 


/*
 * move a message to another room
 */
void cmd_move(args)
char args[]; {
	long num;
	long pos;
	char targ[32];
	int a;
	int targ_slot;
	struct quickroom qtemp;
	struct fullroom ftemp;

	num = extract_long(args,0);
	extract(targ,args,1);
	
	if (curr_rm < 0) {
		printf("%d no room\n",ERROR);
		return;
		}

	getuser(&usersupp,curr_user);
	if ((usersupp.axlevel < 6)
	   && (usersupp.eternal != quickroom.QRroomaide)) {
		printf("%d Higher access required.\n",
			ERROR+HIGHER_ACCESS_REQUIRED);
		return;
		}

	targ_slot = (-1);
	for (a=0; a<MAXROOMS; ++a) {
		getroom(&qtemp,a);
		if (!strucmp(qtemp.QRname,targ)) {
			targ_slot = a;
			a = MAXROOMS;
			}
		}
	if (targ_slot < 0) {
		printf("%d '%s' does not exist.\n",ERROR,targ);
		return;
		}

	/* yank the message out of the current room... */
	lgetroom(&quickroom,curr_rm);
	get_fullroom(&fullroom,curr_rm);

	pos = (-1L);
	for (a=0; a<MSGSPERRM; ++a) {
		if (fullroom.FRnum[a] == num) {
			pos = fullroom.FRpos[a];
			fullroom.FRnum[a] = 0L;
			fullroom.FRpos[a] = 0L;
			}
		}
	if (pos>=0L) {
		sort_fullroom(&fullroom);
		put_fullroom(&fullroom,curr_rm);
		quickroom.QRhighest = fullroom.FRnum[MSGSPERRM-1];
		}
	lputroom(&quickroom,curr_rm);
	if (pos<0L) {
		printf("%d msg %ld does not exist\n",ERROR,num);
		return;
		}

	lgetroom(&qtemp,targ_slot);
	get_fullroom(&ftemp,targ_slot);
	for (a=0; a<MSGSPERRM-1; ++a) {
		ftemp.FRnum[a]=ftemp.FRnum[a+1];
		ftemp.FRpos[a]=ftemp.FRpos[a+1];
		}
	ftemp.FRnum[MSGSPERRM-1] = num;
	ftemp.FRpos[MSGSPERRM-1] = pos;
	sort_fullroom(&ftemp);
	qtemp.QRhighest = ftemp.FRnum[MSGSPERRM-1];
	put_fullroom(&ftemp,targ_slot);
	lputroom(&qtemp,targ_slot);
	printf("%d ok\n",OK);
	}

