/*
 * netmailer for network release 3.0
 * see copyright.doc for copyright information
 *
 * netproc calls this to export Citadel mail to RFC822-compliant mailers.
 *
 */

#include <stdio.h>
#include <fcntl.h>
#include <time.h>
#include "citadel.h"

struct config config;

char temp[20];
long lseek();
long atol();

int haschar(st,ch)
char st[];
int ch; {
	int a,b;
	b=0;
	for (a=0; a<strlen(st); ++a) if (st[a]==ch) ++b;
	return(b);
	}


int struncmp(lstr,rstr,len)
char lstr[],rstr[];
int len; {
	int pos = 0;
	char lc,rc;
	while (pos<len) {
		lc=tolower(lstr[pos]);
		rc=tolower(rstr[pos]);
		if ((lc==0)&&(rc==0)) return(0);
		if (lc<rc) return(-1);
		if (lc>rc) return(1);
		pos=pos+1;
		}
	return(0);
	}


main(argc,argv)
int argc;
char *argv[]; {
	int a,mailtype;
	FILE *fp,*rmail;
	char sbuf[200],rbuf[200],cstr[100],fstr[128],nbuf[64],pbuf[128];
	long mid_buf;

	get_config();	
	sprintf(temp,"/tmp/NetMail.%d",getpid());	/* temp file name */

	if (argc!=2) {
		fprintf(stderr,"netmailer: incorrect usage\n");
		exit(1);
		}

	/* convert to ASCII & get info */
	fp=fopen(temp,"w");
	msgform(argv[1],fp,sbuf,rbuf,nbuf,pbuf,&mid_buf);
	fclose(fp);

	sprintf(cstr,"rmail %s",rbuf);
	rmail=(FILE *)popen(cstr,"w");

	strcpy(fstr,sbuf);
	for (a=0; a<strlen(sbuf); ++a) if (sbuf[a]==32) sbuf[a]='_';
	for (a=0; a<strlen(rbuf); ++a) if (rbuf[a]==32) rbuf[a]='_';

	/*
	 * This logic attempts to compose From and From: lines that are
	 * as RFC822-compliant as possible.  It assumes that you're using
	 * Citadel's rmail/lmail patch to allow BBS users to receive mail
	 * over UUCP or TCP/IP networks.
	 */
	fprintf(rmail,"From ");
	if (strucmp(nbuf,NODENAME)) fprintf(rmail,"%s!",nbuf);

	if (!strucmp(nbuf,NODENAME)) strcpy(nbuf,FQDN);
	if ( (strlen(pbuf)!=0) && (haschar(pbuf,'!')==0) ) {
		fprintf(rmail,"%s\n",pbuf);
		fprintf(rmail,"From: %s@%s (%s)\n",pbuf,FQDN,fstr);
		}
	else {
		fprintf(rmail,"%s\n",sbuf);
		fprintf(rmail,"From: %s@%s (%s)\n",sbuf,nbuf,fstr);
		}

	/*
	 * Everything else is pretty straightforward.
	 */
	fprintf(rmail,"To: %s\nDate: ",rbuf);
	fp=(FILE *)popen("date","r");
	if (fp!=NULL) {
		do {
			a=getc(fp);
			if (a>=0) putc(a,rmail);
			} while(a>=0);
		fclose(fp);
		}
	fprintf(rmail,"Message-Id: <%ld@%s>\n",mid_buf,nbuf);
	fprintf(rmail,"\n");
	fp=fopen(temp,"r");
	if (fp!=NULL) {
		do {
			a=getc(fp);
			if (a>=0) putc(a,rmail);
			} while(a>=0);
		fclose(fp);
		}
	fprintf(rmail,"\n");
	pclose(rmail);
  
	unlink(temp);		/* get rid of the ASCII file */
	exit(0);		/* go back to the main program */
	}


/* This is NOT the same msgform() found in the main program. It has been
 * modified to format 80 columns into a temporary file, and extract the
 * sender and recipient names for use within the main() loop.
 */
msgform(msgfile,mfout,sbuf,rbuf,nbuf,pbuf,mid_buf)
char *msgfile;
FILE *mfout;
char *sbuf;		/* sender */
char *rbuf;		/* recipient (in this case, an Internet address) */
char *nbuf;		/* source node */
char *pbuf;		/* path */
long *mid_buf;		/* message ID */
	{
	struct tm *tm;
	int a,b,c,d,e,real,old,mtype,aflag;
	char aaa[128],bbb[128],ttm[3];
	FILE *fp;
	long now;
	int width;
	long spos;

	strcpy(pbuf,"");	
	strcpy(nbuf,NODENAME);	
	time(mid_buf);
	width=80;
	spos=0L;
	fp=fopen(msgfile,"rb");
	if (fp==NULL) {
		fprintf(stderr,"netmailer: can't open message file\n");
		return(1);
		}
	strcpy(aaa,""); old=255;
	c=1; /* c is the current pos */
	fseek(fp,spos,0);
	e=getc(fp);
	if (e!=255) {
		fprintf(stderr,"Can't find message! Start Byte=%ld\n",spos);
		goto END;
		}
	mtype=getc(fp); aflag=getc(fp);
	goto BONFGM;
A:	if (aflag==1) goto AFLAG;
	old=real; a=getc(fp); real=a;
	if (a==0) goto END;
	if (a<0) goto END;
	
	if ( ((a==13)||(a==10)) && (old!=13) && (old!=10) ) a=32;
	if ( ((old==13)||(old==10)) && ((real==32)||(real==13)||(real==10))) {
						fprintf(mfout,"\n"); c=1; }

	if (a!=32) {
	if ( ((strlen(aaa)+c)>(width-5)) && (strlen(aaa)>(width-5)) )
		{ fprintf(mfout,"\n%s",aaa); c=strlen(aaa); aaa[0]=0; }
	 b=strlen(aaa); aaa[b]=a; aaa[b+1]=0; }
	if (a==32) { 	if ((strlen(aaa)+c)>(width-5)) { 
							fprintf(mfout,"\n");
							c=1;
							}
			fprintf(mfout,"%s ",aaa); ++c; c=c+strlen(aaa);
			strcpy(aaa,""); goto A; }
	if ((a==13)||(a==10)) {
				fprintf(mfout,"%s\n",aaa); c=1;
				strcpy(aaa,""); goto A; }
	goto A;

AFLAG:	a=getc(fp); if (a==0) goto END;
	if (a!=13) putc(a,mfout); if (a==13) putc(10,mfout);
	goto AFLAG;

END:	fclose(fp);
	return(0);

BONFGM:	b=getc(fp); if (b<0) goto END;
	if (b=='M') goto A;
	fpgetfield(fp,bbb);
	if (b=='A') strcpy(sbuf,bbb);
	if (b=='R') strcpy(rbuf,bbb);
	if (b=='N') strcpy(nbuf,bbb);
	if (b=='P') strcpy(pbuf,bbb);
	if (b=='I') *mid_buf = atol(bbb);
	goto BONFGM;
	}

fpgetfield(fp,string)
FILE *fp;
char string[];
{
	int a,b,c;
	strcpy(string,"");
	a=0;
	do {
		b=getc(fp);
		if (b<1) {
			string[a]=0;
			return(0);
			}
		string[a]=b;
		++a;
		} while (b!=0);
	}
