/* More Citadel/UX routines...
 * unlike routines.c, some of these DO use global variables.
 */

#include <fcntl.h>
#include <stdio.h>
#include <ctype.h>
#include <time.h>
#include <signal.h>
#include <pwd.h>
#include <setjmp.h>
#include <termio.h>
#include "citadel.h"

long atol();
long lseek();
long finduser();

extern int errno;
extern char temp[];
extern char tempdir[];
extern char *axdefs[7];
extern long highest_msg_read;
extern long maxmsgnum;
extern unsigned room_flags;

extern int errno;

int eopen(name,mode)
char *name;
int mode; {
	int ret;
	ret = open(name,mode);
	if (ret<0) {
		fprintf(stderr,"Cannot open file '%s', mode=%d, errno=%d\n",
			name,mode,errno);
		interr(errno);
		}
	return(ret);
	}


int room_prompt(qrflags)	/* return proper room prompt character */
int qrflags; {
	int a;
	a='>';
	if (qrflags&QR_DIRECTORY) a=']';
	if ((a==']')&&(qrflags&QR_NETWORK)) a='}';
	if ((a=='>')&&(qrflags&QR_NETWORK)) a=')';
	return(a);
	}

void entregis()	/* register with name and address */
	{

	char buf[256];
	char tmpname[256];
	char tmpaddr[256];
	char tmpcity[256];
	char tmpstate[256];
	char tmpzip[256];
	char tmpphone[256];
	int a;

	strcpy(tmpname,"");
	strcpy(tmpaddr,"");
	strcpy(tmpcity,"");
	strcpy(tmpstate,"");
	strcpy(tmpzip,"");
	strcpy(tmpphone,"");

	serv_puts("GREG _SELF_");
	serv_gets(buf);
	if (buf[0]=='1') {
		a = 0;
		while (serv_gets(buf), strcmp(buf,"000")) {
			if (a==2) strcpy(tmpname,buf);
			if (a==3) strcpy(tmpaddr,buf);
			if (a==4) strcpy(tmpcity,buf);
			if (a==5) strcpy(tmpstate,buf);
			if (a==6) strcpy(tmpzip,buf);
			if (a==7) strcpy(tmpphone,buf);
			++a;
			}
		}

	strprompt("REAL name",tmpname,29);
	strprompt("Address",tmpaddr,24);
	strprompt("City/town",tmpcity,14);
	strprompt("State",tmpstate,2);
	strprompt("ZIP Code",tmpzip,10);
	strprompt("Telephone number",tmpphone,14);

	/* now send the registration info back to the server */
	serv_puts("REGI");
	serv_gets(buf);
	if (buf[0]!='4') {
		printf("%s\n",&buf[4]);
		return;
		}
	serv_puts(tmpname);
	serv_puts(tmpaddr);
	serv_puts(tmpcity);
	serv_puts(tmpstate);
	serv_puts(tmpzip);
	serv_puts(tmpphone);
	serv_puts("000");
	printf("\n");
	}

updatels() {	/* make all messages old in current room */
	int a;
	char buf[256];
	serv_puts("SLRP HIGHEST");
	serv_gets(buf);
	if (buf[0]!='2') printf("%s\n",&buf[4]);
	}

updatelsa() {   /* only make messages old in this room that have been read */
	char buf[256];
	sprintf(buf,"SLRP %ld",highest_msg_read);
	serv_puts(buf);
	serv_gets(buf);
	if (buf[0]!='2') printf("%s\n",&buf[4]);
	}

void upload(c)	/* c = upload mode */
int c; {
	char flnm[256];
	char desc[151];
	char buf[256];
	char tbuf[4096];
	int xfer_pid;
	int a,b;
	FILE *fp,*lsfp;
	int fd;

	if ((room_flags & QR_UPLOAD) == 0) {
		printf("*** You cannot upload to this room.\n");
		return;
		}

	/* we don't need a filename when receiving batch y/z modem */
	if ((c==2)||(c==3)) strcpy(flnm,"x");
	else newprompt("Enter filename: ",flnm,15);

	for (a=0; a<strlen(flnm); ++a)
		if ( (flnm[a]=='/') || (flnm[a]=='\\') || (flnm[a]=='>')
		     || (flnm[a]=='?') || (flnm[a]=='*')
		     || (flnm[a]==';') || (flnm[a]=='&') ) flnm[a]='_';

	newprompt("Enter a short description of the file:\n: ",desc,150);

	/* create a temporary directory... */
	sprintf(buf,"exec mkdir %s",tempdir);
	if (system(buf)!=0) {
		printf("*** Could not create temporary directory %s\n",buf);
		return;
		}

	/* now do the transfer ... in a separate process */
	xfer_pid = fork();
	if (xfer_pid == 0) {
	    chdir(tempdir);
	    switch(c) {
	 	case 0:
			sttybbs(0);
			printf("Receiving %s - press Ctrl-D to end.\n",flnm);
			fp = fopen(flnm,"w");
			do {
				b=inkey(); 
				if (b==13) {
					b=10; printf("\r");
					}
				if (b!=4) {
					printf("%c",b);
					putc(b,fp);
					}
				} while(b!=4);
			fclose(fp);
			exit(0);
	 	case 1:
			sttybbs(3);
			execlp("rx","rx",flnm,NULL);
			exit(1);
	 	case 2:
			sttybbs(3);
			execlp("rb","rb",NULL);
			exit(1);
	 	case 3:
			sttybbs(3);
			execlp("rz","rz",NULL);
			exit(1);
			}
		}
	else do {
		b=wait(&a);
		} while ((b!=xfer_pid)&&(b!=(-1)));
	sttybbs(0);

	if (a != 0) {
		printf("\r*** Transfer unsuccessful.\n");
		sprintf(buf,"rm -fr %s 2>/dev/null",tempdir);
		system(buf);
		return;
		}

	printf("\r*** Transfer successful.  Sending file(s) to server...\n");
	sprintf(buf,"cd %s; ls",tempdir);
	lsfp = popen(buf,"r");
	if (lsfp!=NULL) {
		while (fgets(flnm,256,lsfp)!=NULL) {
			flnm[strlen(flnm)-1] = 0;
			sprintf(buf,"%s/%s",tempdir,flnm);
			fd = open(buf,O_RDONLY);
			if (fd>=0) {
				a = 0;
				do {
					sprintf(buf,"UOPN %s|%s",flnm,desc);
					if (a>0) sprintf(&buf[strlen(buf)],
						".%d",a);
					++a;
					serv_puts(buf);
					serv_gets(buf);
					} while((buf[0]!='2')&&(a<100));
				if (buf[0]=='2') do {
					a=read(fd,tbuf,4096);
					if (a>0) {
						sprintf(buf,"WRIT %d",a);
						serv_puts(buf);
						serv_gets(buf);
						if (buf[0]=='7')
							serv_write(tbuf,a);
						}
					} while (a>0);
				close(fd);
				serv_puts("UCLS 1");
				serv_gets(buf);
				printf("%s\n",&buf[4]);
				}
			}
		pclose(lsfp);
		}

	sprintf(buf,"rm -fr %s 2>/dev/null",tempdir);
	system(buf);
	}

/* 
 * validate a user
 */
void val_user(user)
char *user; {
	int a,b;
	char cmd[256];
	char buf[256];

	sprintf(cmd,"GREG %s",user);
	serv_puts(cmd);
	serv_gets(cmd);
	if (cmd[0]=='1') {
		a = 0;
		do {
			serv_gets(buf);
			++a;
			if (a==1) printf("User #%s - %s  ",
				buf,&cmd[4]);
			if (a==2) printf("PW: %s\n",buf);
			if (a==3) printf("%s\n",buf);
			if (a==4) printf("%s\n",buf);
			if (a==5) printf("%s, ",buf);
			if (a==6) printf("%s ",buf);
			if (a==7) printf("%s\n",buf);
			if (a==8) printf("%s\n",buf);
			if (a==9) printf("Current access level: %d (%s)\n",
				atoi(buf),axdefs[atoi(buf)]);
			} while(strcmp(buf,"000"));
		}
	else {
		printf("%-30s\n%s\n",user,&cmd[4]);
		}

	/* now set the access level */
	do {
		printf("Access level (? for list): ");
		a=inkey();
		if (a=='?') {
			printf("list\n");
			for (b=0; b<7; ++b)
				printf("%d %s\n",b,axdefs[b]);
			}
		a=a-48;
		} while((a<0)||(a>6));
	printf("%d\n\n",a);
	sprintf(cmd,"VALI %s|%d",user,a);
	serv_puts(cmd);
	serv_gets(cmd);
	if (cmd[0]!='2') printf("%s\n",&cmd[4]);
	printf("\n");
	}


void validate() {	/* validate new users */
	char cmd[256];
	char buf[256];
	int finished = 0;
	int a,b;

	do {
		serv_puts("GNUR");
		serv_gets(cmd);
		if (cmd[0]!='3') finished = 1;
		if (cmd[0]=='2') printf("%s\n",&cmd[4]);
		if (cmd[0]=='3') {
			extract(buf,cmd,0);
			val_user(&buf[4]);
			}
		} while(finished==0);
	}

subshell() {
	int a,b;
	a=fork();
	if (a==0) {
		sttybbs(SB_RESTORE);
		signal(SIGINT,SIG_DFL);
		signal(SIGQUIT,SIG_DFL);
		setuid(getuid());
		execlp("/bin/sh","/bin/sh",NULL);
		exit(0);
		}
	do {
		b=wait(NULL);
		} while ((a!=b)&&(a!=(-1)));
	sttybbs(0);
	return(0);
	}

/*
 * <.A>ide <F>ile <D>elete command
 */
void deletefile() {
	char filename[32];
	char cmd[256];

	newprompt("Filename: ",filename,31);
	if (strlen(filename)==0) return;
	sprintf(cmd,"DELF %s",filename);
	serv_puts(cmd);
	serv_gets(cmd);
	printf("%s\n",&cmd[4]);
	}

/*
 * <.A>ide <F>ile <S>end command
 */
void netsendfile() {
	char filename[32],destsys[20],cmd[256];

	newprompt("Filename: ",filename,31);
	if (strlen(filename)==0) return;
	newprompt("System to send to: ",destsys,19);
	sprintf(cmd,"NETF %s|%s",filename,destsys);
	serv_puts(cmd);
	serv_gets(cmd);
	printf("%s\n",&cmd[4]);
	return;
	}

/*
 * <.A>ide <F>ile <M>ove command
 */
void movefile() {
	char filename[64];
	char newroom[20];
	char cmd[256];

	newprompt("Filename: ",filename,63);
	if (strlen(filename)==0) return;
	newprompt("Enter target room: ",newroom,19);

	sprintf(cmd,"MOVF %s|%s",filename,newroom);
	serv_puts(cmd);
	serv_gets(cmd);
	printf("%s\n",&cmd[4]);
	}
