#include <stdio.h>
#include <time.h>
#include <utmp.h>
#include <sys/types.h>
#include <fcntl.h>
#include <signal.h>

#include "mbox.h"



#define LOGVERSION	"1.3"



void sigcatch( sig )
int sig;
{
	signal( SIGHUP, SIG_DFL );
	kill( SIGHUP, 0 );
}
 


main(argc, argv)
int argc;
UNSIGNED char *argv[];
{
  UNSIGNED char s[STRING];
  UNSIGNED char arg[STRING];
  FILE *fp;

  int mboxlogin = 1;
  int fpid;
  int i;
  int telnet = 0;

  char *env_term;
  char *env_logname;

  struct utmp ut;

  int fd;


  if(argv[1][0] == '-'){
	if(argv[1][1] == 'h'){	/* Called by TELNET etc. */
		system( "/bin/cat /etc/issue" );	
		telnet = 1;
	}
	else{
		printf("ix/MBox BBS LOGIN V%s / Check FAQ for information!\n", LOGVERSION);
		exit(0);
	}
  }


  signal(SIGHUP, sigcatch);
  
  env_term = (char *) malloc( (size_t) STRING );
  strcpy(env_term, (char *) "TERM=console");
  putenv( env_term );

  env_logname = (char *) malloc( (size_t) STRING );
  strcpy(env_logname, (char *) "LOGNAME=gast");
  putenv( env_logname );

  sprintf(s, "%s/etc/list.login", HOME);
  fp = fopen(s, "r" );
  if(fp == NULL){
	printf("  ix/MBox LOGIN can't open [%s]!!!", s);
	sleep( 5 );
	sprintf(s, "/bin/login.old -p %s", argv[1]);
	system( s );
  }
  while(fgets(s, STRING, fp) != 0){
	strcpy(s, (UNSIGNED char *) stripped(s));
	if((strlen(s) > 2) && (strlen(argv[1]) > 2) && (s[0] != '#')){
		if(strcomp(s, argv[1]) == 0) mboxlogin = 0;
	}
  }  
  fclose(fp);

  if(telnet == 0){
	strcpy(arg, (UNSIGNED char *) argv[1]);
	for(i = 2; i < argc; i++){
		strcat(arg, (UNSIGNED char *) " ");
		strcat(arg, (UNSIGNED char *) argv[i]);
	}
  }
  else{
	strcpy(arg, (UNSIGNED char *) GUEST);
  }

  if(strcomp("root", argv[1]) == 0) mboxlogin = 0;
 
  if(mboxlogin == 0){
	execlp( "/bin/login.old", "-p", arg, NULL );
  }
  else{
	ut.ut_type = USER_PROCESS;
	ut.ut_pid  = getpid();
	strcpy(s, (char *) ttyna());
	strcpy(ut.ut_line, (char *) s);
	strcpy(s, (char *) strcopy(s, 3, strlen(s)));
	sprintf(ut.ut_id, "%s", (char *) s);
	time( &ut.ut_time );
	strcpy(ut.ut_user, (char *) "bbs");
	strcpy(ut.ut_host, (char *) "ix/MBox BBS");

	fd = open( WTMP_FILE, O_RDWR );
	if(fd != -1){
		(void) lseek( fd, 0L, SEEK_END );
		write(fd, &ut, sizeof(ut) );
		close(fd);		
	}

	pututline( &ut );

	setgid( GUEST_GID );
	setuid( GUEST_UID );

 	system( "/bin/bash /etc/profile");	
	sprintf(s, "%s/mbox %s", HOME, arg);
	system( s );

	ut.ut_user[0] = '\0';
	time( &ut.ut_time );

	fd = open( WTMP_FILE, O_RDWR );
	if(fd != -1){
		(void) lseek( fd, 0L, SEEK_END );
		write(fd, &ut, sizeof(ut) );
		close(fd);		
	}
	endutent();
  }
  signal( SIGHUP, SIG_DFL );
}
